# 安装Docker
## 方式一：在线安装
```
# 下载并安装Docker所需要的软件包
sudo yum install -y yum-utils
# 添加Docker官方的yum仓库地址
sudo yum-config-manager --add-repo https://download.docker.com/linux/centos/docker-ce.repo
# 设置阿里云镜像的yum仓库地址
sudo yum-config-manager --add-repo https://mirrors.aliyun.com/docker-ce/linux/centos/docker-ce.repo
# 更新yum缓存
sudo yum makecache fast
# 安装新版Docker
sudo yum install -y docker-ce docker-ce-cli containerd.io
```
## 方式二：离线安装（如果无法在线安装可尝试此方式）
### 下载Docker安装包
> [https://download.docker.com/linux/static/stable/x86_64/docker-20.10.12.tgz](https://download.docker.com/linux/static/stable/x86_64/docker-20.10.12.tgz)
>
> 如需要安装指定版本可到 [https://download.docker.com/linux/static/stable/x86_64/](https://download.docker.com/linux/static/stable/x86_64/) 下载

### 下载安装脚本
> 到 [https://github.com/Jrohy/docker-install](https://github.com/Jrohy/docker-install) 下载`docker.bash`和`install.sh`两个文件

### 上传文件，正式安装
> 把 `docker-20.10.12.tgz`、`docker.bash`、`install.sh` 三个文件上传到服务器，上传完成后执行安装命令
```
./install.sh -f docker-20.10.12.tgz
```
> 下载完成后看到`Created symlink from /etc/systemd/system/multi-user.target.wants/docker.service to /usr/lib/systemd/system/docker.service.docker 20.10.12 install success!`说明安装成功

# 设置Docker
## 启动Docker
```
# 启动Docker服务
systemctl start docker
# 查看Docker是否启动正常, 看到绿色的active（running）则说明启动正常
systemctl status docker
```

## 设置Docker开机自启
```
systemctl enable docker
```

## 下载Docker镜像时加速
> 直接使用官方镜像的地址比较慢，可配置国内加速镜像。
>
> 使用下面命令直接生成配置文件，或者手动修改`/etc/docker/daemon.json`
```
cat <<EOF > /etc/docker/daemon.json
{
  "registry-mirrors": [
    "https://docker.mirrors.ustc.edu.cn",
    "http://hub-mirror.c.163.com"
  ],
  "max-concurrent-downloads": 10,
  "log-driver": "json-file",
  "log-level": "warn",
  "log-opts": {
    "max-size": "10m",
    "max-file": "3"
    },
  "data-root": "/var/lib/docker"
}
EOF
```

## 重启Docker服务
```
systemctl restart docker
```

## 查看Docker启动状态
```
systemctl status docker
```

> 至此，你已完成Docker的安装和设置，现在你可以使用`docker`命令了。