# 开始安装

# 安装须知

1. 插件端和服务端部署在同一内网
2. 如果不能部署在同一内网请注意插件端的授权账号和密以免泄露，服务端的账号密码设置复杂一些
3. 插件端和服务端不能安装到一个目录
4. 请不要在根目录安装 Jpom

### 安装的环境要求

1. JDK 1.8+
2. 系统配置环境变量`JAVA_HOME`

> 环境变量可在程序管理命令文件`最上方`加入临时环境变量

`Agent.sh/Server.sh`:
```
export JAVA_HOME=/home/Jpom/jdk/jdk1.8.0_152
export JRE_HOME=$JAVA_HOME/jre
export CLASSPATH=.:$JAVA_HOME/lib:$JRE_HOME/lib:$JAVA_HOME/lib/tools.jar
export PATH=$JAVA_HOME/bin:$JRE_HOME/bin:$PATH
```
【`JAVA_HOME=`路径替换成实际jdk路径】

`Agent.bat/Server.bat:`<br>
```
SET JAVA_HOME=D:\Jpom\Java8\jdk1.8.0_101
SET Classpath=%JAVA_HOME%\lib\tools.jar;%JAVA_HOME%\lib\dt.jar;
SET PATH=%PATH%;%JAVA_HOME%\bin;
```
【`JAVA_HOME=`路径替换成实际jdk路径;windows下路径建议`不包含`中文字符】

### 有关实际部署说明

[部署说明](/安装使用/部署说明.md)

# 一键安装（linux）

## 插件端

> 安装的路径位于执行命令目录（数据、日志存放目录默认位于安装路径,如需要修改参考配置文件：[`extConfig.yml`](https://gitee.com/dromara/Jpom/blob/master/modules/agent/src/main/resources/bin/extConfig.yml) ）

```
yum install -y wget && wget -O install.sh https://dromara.gitee.io/jpom/docs/install.sh && bash install.sh Agent

备用地址

yum install -y wget && wget -O install.sh https://cdn.jsdelivr.net/gh/dromara/Jpom/docs/install.sh && bash install.sh Agent

支持自动安装jdk环境

yum install -y wget && wget -O install.sh https://dromara.gitee.io/jpom/docs/install.sh && bash install.sh Agent jdk

```

## 服务端

> 安装的路径位于执行命令目录（数据、日志存放目录默认位于安装路径,如需要修改参考配置文件：[`extConfig.yml`](https://gitee.com/dromara/Jpom/blob/master/modules/server/src/main/resources/bin/extConfig.yml) ）
>
> 如果需要修改数据、日志存储路径请参照 `extConfig.yml` 文件中 `jpom.path` 配置属性

```
yum install -y wget && wget -O install.sh https://dromara.gitee.io/jpom/docs/install.sh && bash install.sh Server

备用地址

yum install -y wget && wget -O install.sh https://cdn.jsdelivr.net/gh/dromara/Jpom/docs/install.sh && bash install.sh Server


支持自动安装jdk环境

yum install -y wget && wget -O install.sh https://dromara.gitee.io/jpom/docs/install.sh && bash install.sh Server jdk

支持自动安装jdk和maven环境

yum install -y wget && wget -O install.sh https://dromara.gitee.io/jpom/docs/install.sh && bash install.sh Server jdk+mvn

```

> 特别提醒：一键安装的时候注意执行命令不可在同一目录下，即Server端和Agent端不可安装在同一目录下


# 下载安装

 > 此方式为我们会在发布每个版本时打包一份为对应版本的安装包提供方便用户快速安装使用的方式

1. 下载安装包 [https://gitee.com/dromara/Jpom/attach_files](https://gitee.com/dromara/Jpom/attach_files)
2. 解压文件
3. 安装插件端（ [流程说明](https://jpom-docs.keepbx.cn/docs/#/安装使用/开始安装?id=安装插件端) ）
    1. agent-x.x.x-release 目录为插件端的全部安装文件
    2. 上传到对应服务器
    3. 命令运行（Agent.sh、Agent.bat）`出现乱码或者无法正常执行,请优先检查编码格式、换行符是否匹配`
    4. 默认运行端口：`2123`
4. 安装服务端（ [流程说明](https://jpom-docs.keepbx.cn/docs/#/安装使用/开始安装?id=安装服务端) ）
    1. server-x.x.x-release 目录为服务端的全部安装文件
    2. 上传到对应服务器
    3. 命令运行（Server.sh、Server.bat）`出现乱码或者无法正常执行,请优先检查编码格式、换行符是否匹配`
    4. 默认运行端口：`2122` 访问管理页面 例如`http://127.0.0.1:2122/`


>安装详细步骤请查阅:[开始安装](/安装使用/开始安装.md)

-----------------------------------------------------------------------------------

### 安装插件端（本案例以liunx服务器为例，windows结构类似）
1. 服务器自定义安装目录,如:`/home/Jpom/Agent`
2. 上传插件端安装包(agent-x.x.x-release.zip)到指定目录，如上:`/home/Jpom/Agent/agent-x.x.x-release.zip`
3. 解压到当前目录，解压后移除安装包后，目录结构如下图：<br>

   ![agent_jieyajiegou](../images/install/agent_jieyajiegou.png "agent_jieyajiegou.png")

    1. `Agent.bat/Agent.sh`: 分别是Windows/Liunx系统下插件端管理程序命令文件
    2. `extConfig.yml`: 为插件端外部配置文件
    3. `lib`: 为插件端主程序jar包存放目录
    
4. 根据自己的需求配置插件端外部配置文件`extConfig.yml`，如下图:<br>

   ![agent_extxmlmoren](../images/install/agent_extxmlmoren.png "agent_extxmlmoren.png")
    
    1. jpom数据存储路径(非必填，默认Jar包父级目录)
    2. agent端管理账号，建议自定义
    3. agent端管理密码，建议自定义
    4. 其他配置项按需配置
   
   【注意：配置项遵守`yml`文件格式和语法，注意`:`后有`空格`】
   
5. 确定插件端运行端口`Agent.sh/Agent.bat`文件中的配置，默认为：2123<br>
   其他参数修改请参考: [启动参数](/安装使用/启动参数.md)
6. `Agent.sh`赋执行权限[sudo chmod +x Agent.sh]
7. `./Agent.sh start` 启动（运行）插件端<br>
   管理命令详情请参考: [管理命令](/安装使用/管理命令.md)
8. 如果已经配置授权账号，那么此插件端的授权账号及为配置的
9. 如果没有配置授权账号或者密码，请注意插件端的启动日志中输出默认的授权账号信息
    1. 默认生成的账号信息规则
    2. 默认账号为：`jpomAgent`
    3. 默认密码为：随机生成的10个字符串
    4. 自动生成的授权账号要写入文件中方便后期查看
    5. 文件具体位置请注意控制台日志
    
   【注意请牢记插件端的授权账号，如果拥有授权端账号信息将可以越过Server用户权限操作节点数据】
10. 如果顺利启动那么Jpom的插件端（agent）算安装成功<br>
    安装失败请参考:[启动失败](/安装使用/启动失败.md)


> 建议插件端仅提供内网访问，不提供外网访问的方式。 一是安全为主，二是减少请求耗时
-----------------------------------------------------------------------------------


### 安装服务端（本案例以liunx服务器为例，windows结构类似）

1. 服务器自定义安装目录,如:`/home/Jpom/Server`
2. 上传服务端安装包(server-x.x.x-release.zip)到指定目录，如上:`/home/Jpom/Server/server-x.x.x-release.zip`
3. 解压到当前目录，解压后移除安装包后，目录结构如下图：<br>

   ![server_jieyajiegou](../images/install/server_jieyajiegou.png "server_jieyajiegou.png")

    1. `Server.bat/Server.sh`: 分别是Windows/Liunx系统下服务端管理程序命令文件
    2. `extConfig.yml`: 为服务端外部配置文件
    3. `lib`: 为服务端主程序jar包存放目录
    
4. 根据自己的需求配置服务端外部配置文件`extConfig.yml`，如下图:<br>

   ![server_extxmlmoren](../images/install/server_extxmlmoren.png "server_extxmlmoren.png")
    
    1. jpom数据存储路径(非必填，默认Jar包父级目录)
    2. `usr`相关参数配置（账号锁定规则）
    3. 其他配置项按需配置
   【注意：配置项遵守`yml`文件格式和语法，注意`:`后有`空格`】
5. 确定服务端运行端口`Server.sh/Server.bat`文件中的配置，默认为：2122<br>
   其他参数修改请参考: [启动参数](/安装使用/启动参数.md)
6. `Server.sh`赋执行权限[sudo chmod +x Server.sh]
7. `./Server.sh start` 启动（运行）服务端<br>
   管理命令详情请参考: [管理命令](/安装使用/管理命令.md)
8. 如果顺利启动那么Jpom的服务端（server）算安装成功<br>
   安装失败请参考:[启动失败](/安装使用/启动失败.md)
9. 启动成功后访问`ip+server端port`，按照提示初始化系统（设置系统管理员账号信息，请牢记系统管理员信息）
    1. 注意此处填写账号密码是设置Jpom系统的系统管理员的账号密码
    2. 系统管理员密码的强度有要求数字+字母+符号
    3. 注意不要把此处账号密码和节点的账号密码混淆

10. 添加节点信息（非必操作项）
    1. 如果在同机器上已经有插件端正在运行，并且当前服务器的节点未空。程序会自动添加本机的插件端到节点中
    2. 节点地址：为安装节点的机器ip地址或者可以访问到节点服务器的域名
    3. 节点端口：插件端端口默认为`2123`，如果自己修改插件端端口则为自己修改的端口
    4. 完整的节点地址为：ip+端口（如果插件端安装在`192.168.2.26`机器上，运行的端口为：`2123` ） 192.168.2.26:2123
    5. 节点的账号和密码和其他详细操作请查阅: [节点安装](/节点管理/添加节点.md)

11. 初始化节点（服务器）
    1. 此处填写您想在服务器运行项目的存放的白名单目录<br>
       `白名单`详情查看[白名单](/节点功能/系统管理/白名单目录.md)
    
12. 进入节点控制台创建项目<br>
    项目的属性说明文档：[查看](/节点功能/项目管理/项目属性.md)

13. 创建管理员、普通成员、服务管理员账号

14. 创建节点分发项目<br>
     节点分发详情请查阅：[分发介绍](/节点分发/分发介绍.md)
15. 愉快的使用Jpom 对Java项目进行运维   


-----------------------------------------------------------------------------------


-----------------------------------------------------------------------------------

### 简易安装流程

1. 下载安装包
2. 上传安装包到服务器
3. 执行对应端管理命令文件（各项配置均采用默认的）
4. 安装完成 


# 容器化安装（docker）

[安装 docker](/安装使用/安装/容器化安装.md)

> 容器化安装仅提供服务端版。由于容器和宿主机环境隔离，而导致插件端的很多功能无法正常使用，因此对插件端容器化意义不大。

```
docker pull jpomdocker/jpom
docker run -d -p 2122:2122 \
	--name jpom-server \
	-v /etc/localtime:/etc/localtime:ro \
	-v /home/jpom-server/log:/usr/local/jpom-server/log \
	-v /home/jpom-server/data:/usr/local/jpom-server/data \
	jpomdocker/jpom
```

## 查看Jpom服务端镜像是否启动成功

> 执行后看到有输出，则说明启动成功，此时可通过`ip:2122`访问服务端
```
docker ps
```

## 查看服务端在宿主机的目录（使用目录挂载创建的容器）
```
日志目录：/home/jpom-server/log
数据目录：/home/jpom-server/data
```

## 查看服务端在宿主机的目录（使用容器卷创建的容器）
> 执行后找到`Mountpoint`字段后面的值，即为宿主机上的目录
```
docker inspect jpom-server-vol
```

# 更新JPOM版本
## 在JPOM项目管理系统中更新（推荐）
1. 首先，你要有一个zip包，可以自己手动打包或者下载我们打包好的最新版的包[https://gitee.com/dromara/Jpom/attach_files](https://gitee.com/dromara/Jpom/attach_files)
   1. 下载里面包含插件端和服务端端包，您需要解压获取服务端包
2. 进入项目管理系统，在右侧的最后找到`系统管理`-->`在线升级`-->点击`选择升级文件`，把你刚才下载好的包上传上去
3. 耐心等待自动更新完成
## 如果是使用Docker的话，还可以去容器卷中替换掉原有的jar包进行更新
1. 同上
2. 打开zip包，找到里面的`lib`目录，把里面的jar文件提取出来，并且把jar文件上传至服务器
3. 找到Docker容器在宿主机的目录（可执行`docker inspect jpom-server-vol`命令查看`Mountpoint`字段的值）
4. 进入宿主机的lib目录，（执行`cat upgrade.json`，查看`newJar`来获取当前jar的名称）
5. 把你上传的jar改成和`newJar`字段同名的值，然后替换掉原来目录里的（如果里面只有一个jar文件，直接改成里面jar文件的名称即可）
6. 重启容器`docker restart jpom-server`

# docker-compose

[安装 docker](/安装使用/安装/容器化安装.md)

- 无需安装任何环境,自动编译构建

> 需要注意修改 `.env` 文件中的 token 值

```shell
git clone https://gitee.com/dromara/Jpom.git
cd Jpom
docker-compose up -d
```

# 编译安装（打包安装）

> 此方式为用户下载最新源码或者定制功能后编译打包安装的方式

1. 访问 [Jpom](https://gitee.com/dromara/Jpom) 的码云主页,拉取最新完整代码(建议使用master分支)
2. 切换到`web-vue`目录 执行`npm install` (vue环境需要提前搭建和安装依赖包详情可以查看web-vue目录下README.md)
3. 执行`npm run build`进行vue项目打包(vue环境需要提前搭建和安装依赖包详情可以查看web-vue目录下README.md)
4. 切换到项目根目录执行:`mvn clean package`
5. 安装插件端（ [流程说明](https://jpom-docs.keepbx.cn/docs/#/安装使用/开始安装?id=安装插件端) ）
    1. 查看插件端安装包 modules/agent/target/agent-x.x.x-release
    2. 打包上传服务器运行
    3. 命令运行（Agent.sh、Agent.bat）`出现乱码或者无法正常执行,请优先检查编码格式、换行符是否匹配`
    4. 默认运行端口：`2123`
6. 安装服务端（ [流程说明](https://jpom-docs.keepbx.cn/docs/#/安装使用/开始安装?id=安装服务端) ）
    1. 查看插件端安装包 modules/server/target/server-x.x.x-release
    2. 打包上传服务器运行
    3. 命令运行（Server.sh、Server.bat）`出现乱码或者无法正常执行,请优先检查编码格式、换行符是否匹配`
    4. 默认运行端口：`2122` 访问管理页面 例如`http://127.0.0.1:2122/`


# 编译运行

1. 访问 [Jpom](https://gitee.com/dromara/Jpom) 的码云主页,拉取最新完整代码(建议使用master分支、如果想体验新功能请使用dev分支)
2. 运行插件端
    1. 运行`io.jpom.JpomAgentApplication`
    2. 注意控制台打印的默认账号密码信息
    3. 默认运行端口：`2123`
3. 运行服务端
    1. 运行`io.jpom.JpomServerApplication`
    2. 默认运行端口：`2122`
4. 构建vue页面 切换到`web-vue`目录（前提需要本地开发环境有node、npm环境）
5. 安装项目vue依赖 控制台执行 `npm install`
6. 启动开发模式 控制台执行 `npm run serve`
7. 根据控制台输出的地址访问前端页面 例如`http://127.0.0.1:3000/`
