# Jpom 中的白名单说明

> Jpom 中的白名单的由来，由于项目管理都需要对项目的文件进行管理。在创建项目的时候需要确定项目的相关文件存放的路径。
> 那么此时由用户决定存放到哪里，显得有点冒然（不安全，有点随意）。因为服务器中有些路径已经存放重要配置文件，此时项目路径相同那么必然没有任何安全性

##### 假设设置黑名单

> 如果设置黑名单那么没有办法最快速收集用户不同服务器中重要文件路径，此方法也显得不合适


### 综上Jpom 就使用白名单来管理项目相关的文件

> 那么在Jpom 中有那些地方需要用到白名单呢

## 1. 项目路径

> 项目路径白名单主要是决定不同项目存放的位置，【但是项目路径选择的白名单不是项目文件存放的实际位置】

> 项目文件存放的实际路径是由【选择的项目路径白名单+项目Jar包】 组合而成的

```
# 举例说明项目白名单如何使用

如果有4个项目需要部署到服务器中，但是4个项目又可以分为两大类型

项目1、项目2、项目3、项目4

可以分为：后台、接口

【后台】：项目1、项目3

【接口】：项目2、项目4

那么推荐配置白名单：

/project/admin/
/project/api/

那么在创建项目1、项目3的时候选择路径：/project/admin/

那么在创建项目2、项目4的时候选择路径：/project/api/

```

## 2. 证书路径

> 证书路径白名单是决定用户上次的ssl 证书存放的路径

> 证书文件实际存放的路径是由【选择的证书路径白名单+证书id+id.key(id.pem)】 组合而成的

## 3. Nginx路径

> Nginx路径白名单是决定Jpom 程序会自动扫描对应目录下的 *.conf 文件还展示配置文件

## 4. 节点分发

> 节点分发白名单是决定创建节点分发项目时候，项目的白名单路径（此处规则和项目路径白名单一致）

> 单独管理节点分发白名单的目的是为了多节点的白名单信息同步


# 注意：为了系统安全白名单只允许系统管理配置，在节点第一次使用时候为了系统能正常使用需要添加一个项目的白名单路径