## 项目属性说明

### 1. 项目名称

> 为项目取一个动听的名字

### 2. 分组名称

> 是为了在多个项目中区分和在项目列表中快速选择
### 3. 项目ID

> 一旦创建后是无法修改的(Jpom中以项目ID为参照判断程序运行状态)

### 4. 运行方式

> Jpom目前支持两种运行方式 jar和classpath jar即为运行jar包（java -jar） classpath即为运行多个jar(java -classpath)

### 5. 项目路径

> 为在白名单中配置的信息

> 在创建项目时候需要选择对应的一个目录以来决定项目的实际jar包信息会存放在对应的目录之下

### 6. 项目Jar包即为项目存放jar包的文件夹路径（注意是文件夹而不是文件）

> 注意项目的实际jar存放的路径是以 选择的项目路径+填写的项目jar包路径，如图：选择的项目路径为(D:/dev) 填写的项目jar包为(sss) 
> 那么项目实际的jar会存放在 D:/dev/sss 文件夹中

> 同时注意最终的项目实际路径限制如下：
> 1. 如果实际路径为一个已经存在的文件，是不可以创建对应的项目的
> 2. 如果实际路径是一个已经存在的文件夹，那么项目的文件会直接使用的
> 3. 如果在修改项目jar包含子项目路径时，遇到新的实际路径已经存在，那么程序复制原实际路径中的所有文件到新的实际路径中，存在相同的则覆盖

### 7. MainClass

> 程序的主类，当项目运行方式为Jar时此项必填

### 8. WebHooks 

> 当关闭Jpom时，程序会自动请求对应的路径(get方式请求)

### 9. Build标识

> 需要和阿里云oss配置配合使用

### 10. Jvm参数

> 设置java虚拟机参数

> 如：-Xmin=512m -Xmax=512m

### 11. Args参数

> 程序运行的main方式参数

> 如：--service.port=8080

## maven 快速创建项目

1. 在pom 中添加插件如下，具体配置信息请自行修改为对应项目
```
 <plugin>
    <groupId>io.jpom.jpom-plugin</groupId>
    <artifactId>jpom-maven-plugin</artifactId>
    <version>LATEST</version>
    <configuration>
        <!--节点地址 -->
        <url>http://127.0.0.1:2122</url>
        <nodeIds>
            <nodeId>localhost</nodeId>
        </nodeIds>
        <!--用户token -->
        <token>5610b7db99f7216e4ed3543f2a56eb95</token>
        <project>
            <name>测试</name>
            <id>ss</id>
            <runMode>File</runMode>
            <path>dfgdsfg</path>
            <whitelistDirectory>/test/</whitelistDirectory>
            <!--非必填-->
            <mainClass></mainClass>
            <jvm></jvm>
            <args></args>
            <webHook></webHook>
        </project>
    </configuration>
    <executions>
        <execution>
            <goals>
                <goal>jpom-project</goal>
            </goals>
        </execution>
    </executions>
</plugin>
```

2. 执行命令

```
mvn clean package
```

